import React from 'react';

var styles = {"textboxwrapper":"_1twP4","bordereffect":"_3cVOs","effect_1":"_1quaz","effect_2":"_3z3X2","effect_3":"_7avJu","focus_border":"_8TKmZ","effect_4":"_2Zj_F","effect_5":"_NwP0R","effect_6":"_3ywkA","effect_7":"_2V7eF","effect_8":"_q39y5","effect_9":"_sohc-","br_s_i":"_3sRWz","backgroundeffect":"_1xd5P","focus_bg":"_1lDGS","labeleffect":"_2eBPT","has_content":"_2Yg__","inp_label":"_2f4YC","has-conten":"_2KN42","switch_wrapper":"_KXxu_","pure_material_switch":"_2uI-Q","switch_input":"_Fd1d2","switch_span":"_14DO5","checkbox_wrapper":"_2h0NG","pure_material_checkbox":"_3KMWw","checkbox_input":"_3E3Ux","cbChecked":"_1Q1zg","checkbox_span":"_KrQRR","label_text":"_2G-6J","checkbox_material":"_T8duf","check":"_1Z6CV","checkbox-off":"_bPSem","checkbox-on":"_3gJEg","rippleOff":"_25gNl","rippleOn":"_rB5aB","radio_button_wrapper":"_2Ibjr","pure_material_radio":"_T5O4M","radio_input":"_3IdSo","rbChecked":"_2ruoV","select_wrapper_material":"_yoqu0","search_select":"_mMad8","combo_input":"_1z8bk","material_custom_select":"_1M8Lc","material_custom_select_item":"_1DQUo","opened":"_1TVUI","active_item":"_4rpkO","select_label":"_3FOa_","floated":"_320FY","combo-marker":"_4oibn","multi_select":"_3E8Yd","value_wrapper":"_35jFe","with_value":"_vwzI6","value_item":"_3Ze4Y","scale_opacity":"_1fLeR","close_icon":"_MkRVp"};

BorderEffect.defaultProps = {
  value: '',
  type: 'text',
  placeholder: 'Enter Text',
  standard: 'bordereffect',
  readOnly: false,
  effect: 'effect_1'
};
function BorderEffect(props) {
  var value = props.value,
      type = props.type,
      placeholder = props.placeholder,
      readOnly = props.readOnly,
      handleOnChange = props.handleOnChange,
      effect = props.effect,
      standard = props.standard;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.textboxwrapper + " " + styles[standard]
  }, /*#__PURE__*/React.createElement("input", {
    className: styles[effect],
    type: type || '',
    value: value,
    placeholder: placeholder,
    onChange: function onChange(e) {
      return handleOnChange(e.target.value);
    },
    readOnly: readOnly
  }), /*#__PURE__*/React.createElement("span", {
    className: styles.focus_border
  }, effect === "effect_9" || effect === "effect_8" || effect === "effect_7" ? /*#__PURE__*/React.createElement("i", {
    className: styles.br_s_i
  }) : null));
}

BackgroundEffect.defaultProps = {
  value: '',
  type: 'text',
  placeholder: 'Enter Text',
  standard: 'backgroundeffect',
  readOnly: false,
  effect: 'effect_1'
};
function BackgroundEffect(props) {
  var value = props.value,
      type = props.type,
      placeholder = props.placeholder,
      readOnly = props.readOnly,
      handleOnChange = props.handleOnChange,
      effect = props.effect,
      standard = props.standard;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.textboxwrapper + " " + styles[standard]
  }, /*#__PURE__*/React.createElement("input", {
    className: styles[effect],
    type: type || '',
    value: value,
    placeholder: placeholder,
    onChange: function onChange(e) {
      return handleOnChange(e.target.value);
    },
    readOnly: readOnly
  }), /*#__PURE__*/React.createElement("span", {
    className: styles.focus_bg
  }, "  "));
}

LabelEffect.defaultProps = {
  value: '',
  type: 'text',
  placeholder: 'Enter Text',
  standard: 'label_effect',
  readOnly: false,
  effect: 'effect_1'
};
function LabelEffect(props) {
  var value = props.value,
      type = props.type,
      placeholder = props.placeholder,
      readOnly = props.readOnly,
      handleOnChange = props.handleOnChange,
      effect = props.effect,
      standard = props.standard,
      keys = props.keys;

  function renderSubClass(value) {
    if (type === "number" || type === "NUMBER") {
      if (String(value.length) >= 1) {
        return 'has_content';
      } else {
        return '';
      }
    } else {
      value = value.trim();

      if (value.length >= 1) {
        return 'has_content';
      } else {
        return '';
      }
    }
  }

  return /*#__PURE__*/React.createElement("div", {
    className: styles.textboxwrapper + " " + styles[standard]
  }, /*#__PURE__*/React.createElement("input", {
    id: keys,
    className: styles[effect] + " " + styles[renderSubClass(value)],
    type: type || '',
    value: value,
    placeholder: '',
    onChange: function onChange(e) {
      return handleOnChange(e.target.value);
    },
    readOnly: readOnly
  }), /*#__PURE__*/React.createElement("label", {
    htmlFor: keys,
    className: styles.inp_label
  }, placeholder), /*#__PURE__*/React.createElement("span", {
    className: effect === "effect_7" || effect === "effect_8" || effect === "effect_9" ? styles.focus_bg : styles.focus_border
  }, effect === "effect_4" || effect === "effect_5" || effect === "effect_6" ? /*#__PURE__*/React.createElement("i", {
    className: styles.br_s_i
  }) : null));
}

Switch.defaultProps = {
  value: '',
  label: '',
  readOnly: false
};
function Switch(props) {
  var value = props.value,
      label = props.label,
      hanldeOnChange = props.hanldeOnChange;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.switch_wrapper
  }, /*#__PURE__*/React.createElement("label", {
    className: styles.pure_material_switch
  }, /*#__PURE__*/React.createElement("input", {
    checked: value,
    onChange: function onChange(e) {
      return hanldeOnChange(e.target.checked);
    },
    className: styles.switch_input,
    type: "checkbox"
  }), /*#__PURE__*/React.createElement("span", {
    className: styles.switch_span
  }, label)));
}

CheckBox.defaultProps = {
  value: '',
  label: '',
  effect: 'effect_1',
  disabled: false,
  readOnly: false
};
function CheckBox(props) {
  var value = props.value,
      label = props.label,
      effect = props.effect,
      keys = props.keys,
      hanldeOnChange = props.hanldeOnChange,
      valueToBeReturned = props.valueToBeReturned,
      disabled = props.disabled;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.checkbox_wrapper
  }, effect === 'effect_1' ? /*#__PURE__*/React.createElement("div", {
    className: styles[effect]
  }, /*#__PURE__*/React.createElement("label", {
    className: styles.pure_material_checkbox
  }, /*#__PURE__*/React.createElement("input", {
    disabled: disabled,
    checked: value,
    onChange: function onChange(e) {
      return hanldeOnChange(valueToBeReturned);
    },
    className: styles.checkbox_input + " " + (value ? styles.cbChecked : null),
    type: "checkbox"
  }), /*#__PURE__*/React.createElement("span", {
    className: styles.checkbox_span
  }, label))) : effect === 'effect_2' ? /*#__PURE__*/React.createElement("div", {
    className: styles[effect]
  }, /*#__PURE__*/React.createElement("label", {
    className: styles.pure_material_checkbox
  }, /*#__PURE__*/React.createElement("input", {
    type: "checkbox",
    disabled: disabled,
    checked: value,
    onChange: function onChange(e) {
      return hanldeOnChange(valueToBeReturned);
    },
    id: keys,
    className: styles.checkbox_input + " " + (value ? styles.cbChecked : null)
  }), /*#__PURE__*/React.createElement("span", {
    "class": styles.checkbox_material
  }, /*#__PURE__*/React.createElement("span", {
    "class": styles.check
  })), /*#__PURE__*/React.createElement("span", {
    className: styles.label_text
  }, label))) : /*#__PURE__*/React.createElement("p", null, "You have passed invalid effect value"));
}

RadioButton.defaultProps = {
  value: '',
  label: '',
  effect: 'effect_1',
  group: 'group',
  disabled: false,
  readOnly: false
};
function RadioButton(props) {
  var value = props.value,
      label = props.label,
      group = props.group,
      hanldeOnChange = props.hanldeOnChange,
      valueToBeReturned = props.valueToBeReturned,
      disabled = props.disabled;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.radio_button_wrapper
  }, /*#__PURE__*/React.createElement("label", {
    className: styles.pure_material_radio
  }, /*#__PURE__*/React.createElement("input", {
    type: "radio",
    name: group,
    disabled: disabled,
    checked: value,
    onChange: function onChange(e) {
      return hanldeOnChange(valueToBeReturned);
    },
    className: styles.radio_input + " " + (value ? styles.rbChecked : null)
  }), /*#__PURE__*/React.createElement("span", {
    className: styles.label_text
  }, label)));
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var Select = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Select, _React$Component);

  function Select(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _this.handleFocus = function (event) {
      _this.setState({
        isOpened: true
      });
    };

    _this.renderOption = function (option, value, tempvalue, filterValue, filter) {
      var notfound = 0;

      if (option.length >= 1 && typeof option[0] === 'object') {
        return option.map(function (item, i) {
          if (filter && filterValue.trim().length >= 1) {
            if (item.value.toUpperCase().includes(filterValue.toUpperCase())) {
              return /*#__PURE__*/React.createElement("li", {
                key: 'select' + i,
                onClick: function onClick(e) {
                  return _this.handleChange(e, item.value);
                },
                className: styles.material_custom_select_item + " " + (tempvalue === item.value ? styles.active_item : ''),
                "data-index": i + 1
              }, item.label);
            } else {
              notfound++;

              if (notfound === option.length) {
                return /*#__PURE__*/React.createElement("li", {
                  className: "" + styles.material_custom_select_item
                }, /*#__PURE__*/React.createElement("span", null, "Not Found"));
              } else {
                return null;
              }
            }
          } else {
            return /*#__PURE__*/React.createElement("li", {
              key: 'select' + i,
              onClick: function onClick(e) {
                return _this.handleChange(e, item.value);
              },
              className: styles.material_custom_select_item + " " + (tempvalue === item.value ? styles.active_item : ''),
              "data-index": i + 1
            }, item.label);
          }
        });
      } else {
        return option.map(function (item, i) {
          if (filter && filterValue.trim().length >= 1) {
            if (item.toUpperCase().includes(filterValue.toUpperCase())) {
              return /*#__PURE__*/React.createElement("li", {
                key: 'select' + i,
                onClick: function onClick(e) {
                  return _this.handleChange(e, item);
                },
                className: styles.material_custom_select_item + " " + (tempvalue === item ? styles.active_item : ''),
                "data-index": i + 1
              }, item);
            } else {
              notfound++;

              if (notfound === option.length) {
                return /*#__PURE__*/React.createElement("li", {
                  className: "" + styles.material_custom_select_item
                }, /*#__PURE__*/React.createElement("span", null, "Not Found"));
              } else {
                return null;
              }
            }
          } else {
            return /*#__PURE__*/React.createElement("li", {
              key: 'select' + i,
              onClick: function onClick(e) {
                return _this.handleChange(e, item);
              },
              className: styles.material_custom_select_item + " " + (tempvalue === item ? styles.active_item : ''),
              "data-index": i + 1
            }, item);
          }
        });
      }
    };

    _this.state = {
      tempvalue: null,
      filterValue: '',
      isOpened: false,
      isFloated: false
    };
    _this.textInput = React.createRef();
    _this.handleKeyDown = _this.handleKeyDown.bind(_assertThisInitialized(_this));
    _this.handleClickOutside = _this.handleClickOutside.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = Select.prototype;

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener("keydown", this.handleKeyDown, false);
    document.addEventListener('mousedown', this.handleClickOutside, false);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener("keydown", this.handleKeyDown, false);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (this.props.value !== prevProps.value) {
      this.setState({
        filterValue: this.props.value,
        value: this.props.value
      });
    }
  };

  _proto.handleClickOutside = function handleClickOutside(e) {
    if (this.state.isOpened && this.handleDocumentClickRef.contains(e.target) === false) {
      if (this.state.tempvalue === null) {
        this.handleFloatLabel(false);
      }

      this.setState({
        isOpened: false
      });
    }
  };

  _proto.handleKeyDown = function handleKeyDown(e) {
    var _this2 = this;

    var keyCodes = [40, 38, 13, 9];
    var keyCode = e.keyCode;
    var tempvalue = this.state.tempvalue;
    var option = this.props.option;
    var values = [];

    if (option.length >= 1 && typeof option[0] === 'object') {
      values = option.map(function (item) {
        return item.value;
      });
    } else {
      values = option;
    }

    if (this.state.isOpened && keyCodes.includes(keyCode)) {
      if ((keyCode === 38 || keyCode === 40) && tempvalue === null) {
        tempvalue = values[0];
      } else if (keyCode === 40) {
        var index = values.indexOf(tempvalue);
        tempvalue = index === values.length - 1 ? values[0] : values[index + 1];
      } else if (keyCode === 38) {
        var _index = values.indexOf(tempvalue);

        tempvalue = _index === 0 ? values[values.length - 1] : values[_index - 1];
      } else if (keyCode === 13) {
        this.setState({
          isOpened: false
        }, function () {
          _this2.textInput.current.blur();

          _this2.props.hanldeOnChange(tempvalue);
        });
      } else if (keyCode === 9) {
        if (this.state.tempvalue === null) {
          this.handleFloatLabel(false);
        }

        this.setState({
          isOpened: false
        });
      }
    }

    this.setState({
      tempvalue: tempvalue
    });
  };

  _proto.handleChange = function handleChange(e, value) {
    var _this3 = this;

    e.preventDefault();
    this.setState({
      isOpened: false,
      tempvalue: value
    }, function () {
      _this3.props.hanldeOnChange(value);
    });
  };

  _proto.handleBlur = function handleBlur() {
    this.setState({
      isOpened: false
    });
  };

  _proto.handleFloatLabel = function handleFloatLabel(value) {
    this.setState({
      isFloated: value
    });
  };

  _proto.render = function render() {
    var _this4 = this;

    var _this$state = this.state,
        isOpened = _this$state.isOpened,
        tempvalue = _this$state.tempvalue,
        isFloated = _this$state.isFloated,
        filterValue = _this$state.filterValue;
    var _this$props = this.props,
        option = _this$props.option,
        label = _this$props.label,
        value = _this$props.value,
        keys = _this$props.keys,
        filter = _this$props.filter;
    return /*#__PURE__*/React.createElement("div", {
      className: styles.select_wrapper_material + " " + (isOpened ? styles.opened : '') + " " + (isFloated ? styles.floated : '')
    }, /*#__PURE__*/React.createElement("form", {
      autoComplete: "new-form"
    }, /*#__PURE__*/React.createElement("label", {
      htmlFor: keys,
      className: styles.select_label
    }, label), /*#__PURE__*/React.createElement("input", {
      type: "text",
      value: filterValue,
      id: keys,
      ref: this.textInput,
      autoComplete: "new-off",
      onFocus: function onFocus(event) {
        return [event.target.setAttribute('autocomplete', 'off'), _this4.handleFocus(event), _this4.handleFloatLabel(true)];
      },
      readOnly: !filter,
      onChange: filter ? function (e) {
        return _this4.setState({
          filterValue: e.target.value
        });
      } : function () {
        return console.log();
      },
      className: styles.combo_input
    })), /*#__PURE__*/React.createElement("ul", {
      ref: function ref(node) {
        return _this4.handleDocumentClickRef = node;
      },
      className: styles.material_custom_select
    }, this.renderOption(option, value, tempvalue, filterValue, filter)));
  };

  return Select;
}(React.Component);
Select.defaultProps = {
  value: '',
  label: '',
  effect: 'effect_1',
  disabled: false,
  readOnly: false,
  option: [],
  filter: false,
  multi: false,
  maxCount: 0
};

var MultiSelect = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(MultiSelect, _React$Component);

  function MultiSelect(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _this.getCurrentSelectedValue = function (allValues, value, position, key) {
      var indexes = value.map(function (item) {
        return allValues.indexOf(item);
      });

      if (key === 'down_up' || key === 'down') {
        if (indexes.includes(position)) {
          return _this.getCurrentSelectedValue(allValues, value, position === allValues.length - 1 ? 0 : position + 1, key);
        } else {
          return position;
        }
      } else if (key === 'up') {
        if (indexes.includes(position)) {
          return _this.getCurrentSelectedValue(allValues, value, position === 0 ? allValues.length - 1 : position - 1, key);
        } else {
          return position;
        }
      }
    };

    _this.handleFocus = function (event) {
      _this.setState({
        isOpened: true
      });
    };

    _this.renderOption = function (option, value, tempvalue, filterValue, filter) {
      var notfound = 0;

      if (option.length >= 1 && typeof option[0] === 'object') {
        return option.map(function (item, i) {
          if (filter && filterValue.trim().length >= 1) {
            if (item.value.toUpperCase().includes(filterValue.toUpperCase()) && !value.includes(item.value)) {
              return /*#__PURE__*/React.createElement("li", {
                key: 'select' + i,
                onClick: function onClick(e) {
                  return _this.handleChange(e, item.value);
                },
                className: styles.material_custom_select_item + " " + (tempvalue === item.value ? styles.active_item : ''),
                "data-index": i + 1
              }, item.label);
            } else {
              notfound++;

              if (notfound === option.length) {
                return /*#__PURE__*/React.createElement("li", {
                  className: "" + styles.material_custom_select_item
                }, /*#__PURE__*/React.createElement("span", null, "Not Found"));
              } else {
                return null;
              }
            }
          } else if (!value.includes(item.value)) {
            return /*#__PURE__*/React.createElement("li", {
              key: 'select' + i,
              onClick: function onClick(e) {
                return _this.handleChange(e, item.value);
              },
              className: styles.material_custom_select_item + " " + (tempvalue === item.value ? styles.active_item : ''),
              "data-index": i + 1
            }, item.label);
          }
        });
      } else {
        return option.map(function (item, i) {
          if (filter && filterValue.trim().length >= 1) {
            if (item.toUpperCase().includes(filterValue.toUpperCase()) && !value.includes(item)) {
              return /*#__PURE__*/React.createElement("li", {
                key: 'select' + i,
                onClick: function onClick(e) {
                  return _this.handleChange(e, item);
                },
                className: styles.material_custom_select_item + " " + (tempvalue === item ? styles.active_item : ''),
                "data-index": i + 1
              }, item);
            } else {
              notfound++;

              if (notfound === option.length) {
                return /*#__PURE__*/React.createElement("li", {
                  className: "" + styles.material_custom_select_item
                }, /*#__PURE__*/React.createElement("span", null, "Not Found"));
              } else {
                return null;
              }
            }
          } else if (!value.includes(item)) {
            return /*#__PURE__*/React.createElement("li", {
              key: 'select' + i,
              onClick: function onClick(e) {
                return _this.handleChange(e, item);
              },
              className: styles.material_custom_select_item + " " + (tempvalue === item ? styles.active_item : ''),
              "data-index": i + 1
            }, item);
          }
        });
      }
    };

    _this.handleArrayRemoveItem = function (index, value) {
      _this.setState({
        isOpened: false,
        tempvalue: null,
        filterValue: ''
      }, function () {
        value.splice(index, 1);

        _this.props.hanldeOnChange(value);
      });
    };

    _this.renderValues = function (value) {
      var maxResultCount = _this.props.maxResultCount;
      return value.map(function (data, i) {
        if (maxResultCount !== undefined && maxResultCount !== 0) {
          if (i < maxResultCount) {
            return /*#__PURE__*/React.createElement("li", {
              key: i,
              className: styles.value_item
            }, /*#__PURE__*/React.createElement("span", null, data), /*#__PURE__*/React.createElement("span", {
              onClick: function onClick() {
                return _this.handleArrayRemoveItem(i, value);
              },
              className: styles.close_icon,
              "aria-label": "close-icon"
            }));
          } else if (i === maxResultCount) {
            return /*#__PURE__*/React.createElement("li", {
              key: i,
              className: styles.value_item
            }, /*#__PURE__*/React.createElement("span", null, "+ " + (value.length - maxResultCount)));
          }

          return null;
        } else {
          return /*#__PURE__*/React.createElement("li", {
            key: i,
            className: styles.value_item
          }, /*#__PURE__*/React.createElement("span", {
            className: styles.value_item_text
          }, data), /*#__PURE__*/React.createElement("span", {
            onClick: function onClick() {
              return _this.handleArrayRemoveItem(i, value);
            },
            className: styles.close_icon,
            "aria-label": "close-icon"
          }));
        }
      });
    };

    _this.state = {
      tempvalue: null,
      filterValue: '',
      maxResultCount: 0,
      isOpened: false,
      isFloated: false
    };
    _this.textInput = React.createRef();
    _this.handleKeyDown = _this.handleKeyDown.bind(_assertThisInitialized(_this));
    _this.handleClickOutside = _this.handleClickOutside.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = MultiSelect.prototype;

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener("keydown", this.handleKeyDown, false);
    document.addEventListener('mousedown', this.handleClickOutside, false);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener("keydown", this.handleKeyDown, false);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (this.props.value !== prevProps.value) {
      this.setState({
        filterValue: this.props.value,
        value: this.props.value
      });
    }
  };

  _proto.handleClickOutside = function handleClickOutside(e) {
    if (this.state.isOpened && this.handleDocumentClickRef.contains(e.target) === false) {
      if (this.state.tempvalue === null) {
        this.handleFloatLabel(false);
      }

      this.setState({
        isOpened: false
      });
    }
  };

  _proto.handleKeyDown = function handleKeyDown(e) {
    var _this2 = this;

    var keyCodes = [40, 38, 13, 9];
    var keyCode = e.keyCode;
    var tempvalue = this.state.tempvalue;
    var _this$props = this.props,
        option = _this$props.option,
        value = _this$props.value;
    var values = [];

    if (option.length >= 1 && typeof option[0] === 'object') {
      values = option.map(function (item) {
        return item.value;
      });
    } else {
      values = option;
    }

    if (this.state.isOpened && keyCodes.includes(keyCode)) {
      if ((keyCode === 38 || keyCode === 40) && tempvalue === null) {
        tempvalue = values[this.getCurrentSelectedValue(values, value, 0, 'down_up')];
      } else if (keyCode === 40) {
        var index = values.indexOf(tempvalue);
        tempvalue = index === values.length - 1 ? values[this.getCurrentSelectedValue(values, value, 0, 'down')] : values[this.getCurrentSelectedValue(values, value, index + 1, 'down')];
      } else if (keyCode === 38) {
        var _index = values.indexOf(tempvalue);

        tempvalue = _index === 0 ? values[this.getCurrentSelectedValue(values, value, values.length - 1, 'up')] : values[this.getCurrentSelectedValue(values, value, _index - 1, 'up')];
      } else if (keyCode === 13) {
        this.setState({
          isOpened: false,
          filterValue: ''
        }, function () {
          var prevValues = _this2.props.value;
          prevValues.push(tempvalue);

          _this2.textInput.current.blur();

          _this2.props.hanldeOnChange(prevValues);
        });
      } else if (keyCode === 9) {
        if (this.state.tempvalue === null) {
          this.handleFloatLabel(false);
        }

        this.setState({
          isOpened: false
        });
      }
    }

    this.setState({
      tempvalue: tempvalue
    });
  };

  _proto.handleChange = function handleChange(e, value) {
    var _this3 = this;

    e.preventDefault();
    this.setState({
      isOpened: false,
      tempvalue: null,
      filterValue: ''
    }, function () {
      var prevValues = _this3.props.value;
      prevValues.push(value);

      _this3.props.hanldeOnChange(prevValues);
    });
  };

  _proto.handleBlur = function handleBlur() {
    this.setState({
      isOpened: false
    });
  };

  _proto.handleFloatLabel = function handleFloatLabel(value) {
    this.setState({
      isFloated: value
    });
  };

  _proto.render = function render() {
    var _this4 = this;

    var _this$state = this.state,
        isOpened = _this$state.isOpened,
        tempvalue = _this$state.tempvalue,
        isFloated = _this$state.isFloated,
        filterValue = _this$state.filterValue;
    var _this$props2 = this.props,
        option = _this$props2.option,
        label = _this$props2.label,
        value = _this$props2.value,
        keys = _this$props2.keys,
        filter = _this$props2.filter;
    return /*#__PURE__*/React.createElement("div", {
      className: styles.select_wrapper_material + " " + (value.length >= 1 ? styles.with_value : '') + " " + styles.multi_select + " " + (isOpened ? styles.opened : '') + " " + (isFloated ? styles.floated : '') + "\n            "
    }, /*#__PURE__*/React.createElement("ul", {
      className: "" + styles.value_wrapper
    }, this.renderValues(value)), /*#__PURE__*/React.createElement("form", {
      autoComplete: "new-form"
    }, /*#__PURE__*/React.createElement("label", {
      htmlFor: keys,
      className: styles.select_label
    }, label), /*#__PURE__*/React.createElement("input", {
      type: "text",
      value: filterValue,
      id: keys,
      ref: this.textInput,
      autoComplete: "new-off",
      onFocus: function onFocus(event) {
        return [event.target.setAttribute('autocomplete', 'off'), _this4.handleFocus(event), _this4.handleFloatLabel(true)];
      },
      readOnly: !filter,
      onChange: filter ? function (e) {
        return _this4.setState({
          filterValue: e.target.value
        });
      } : function () {
        return console.log();
      },
      className: styles.combo_input
    })), /*#__PURE__*/React.createElement("ul", {
      ref: function ref(node) {
        return _this4.handleDocumentClickRef = node;
      },
      className: styles.material_custom_select
    }, this.renderOption(option, value, tempvalue, filterValue, filter)));
  };

  return MultiSelect;
}(React.Component);
MultiSelect.defaultProps = {
  value: [],
  label: '',
  effect: 'effect_1',
  disabled: false,
  readOnly: false,
  option: [],
  filter: false,
  multi: false,
  maxCount: 0
};

var FormField = function FormField(props) {
  var type = props.type,
      standard = props.standard;

  if (type.toUpperCase() === 'TEXT' || type.toUpperCase() === 'PASSWORD' || type.toUpperCase() === 'NUMBER' || type.toUpperCase() === 'EMAIL') {
    if (standard.toUpperCase() === 'BORDEREFFECT') {
      return /*#__PURE__*/React.createElement(BorderEffect, props);
    } else if (standard.toUpperCase() === 'BACKGROUNDEFFECT') {
      return /*#__PURE__*/React.createElement(BackgroundEffect, props);
    } else if (standard.toUpperCase() === 'LABELEFFECT') {
      return /*#__PURE__*/React.createElement(LabelEffect, props);
    } else {
      return /*#__PURE__*/React.createElement("p", null, "Standara property shouold have BORDEREFFECT,BACKGROUNDEFFECT,LABELEFFECT as a props value");
    }
  } else if (type.toUpperCase() === 'SELECT') {
    var multi = props.multi,
        multiple = props.multiple;

    if (multi || multiple) {
      return /*#__PURE__*/React.createElement(MultiSelect, props);
    } else {
      return /*#__PURE__*/React.createElement(Select, props);
    }
  } else if (type.toUpperCase() === 'CHECKBOX') {
    return /*#__PURE__*/React.createElement(CheckBox, props);
  } else if (type.toUpperCase() === 'RADIO' || type.toUpperCase() === 'RADIOBUTTON') {
    return /*#__PURE__*/React.createElement(RadioButton, props);
  } else if (type.toUpperCase() === 'SWITCH') {
    return /*#__PURE__*/React.createElement(Switch, props);
  } else {
    return /*#__PURE__*/React.createElement("p", null, "Your expected form is not available in our Liabary. will keep you upate next version pelase.");
  }
};

export { FormField };
//# sourceMappingURL=index.modern.js.map
